# Writing & Maintaining Tests

Pilgrim's tests are written using the testify framework and mockery.

#### Generate Mocks

The below command, when executed from the project root, will generate mocks for
all interfaces in all packages of the project, and put them in the `mocks`
directory, under the `pilgrim_mock` package

```bash
mockery --all --outpkg pilgrim_mock --output ./internal/mocks
```

#### Run Tests

To run all tests, execute the following from the root directory

```bash
go test ./...
```